// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.
form(nz-form, [formGroup]="form")
  nz-form-item(*ngFor="let input of config", [formGroupName]="input.id")
    div.iotitle
      nz-form-label([nzFor]="input.name")
        span {{ input.name }}
      span.iotype {{ input.optional === true ? "Optional " : "" }}
      span.iotype &nbsp;&nbsp;{{ input.inputType }}
    nz-form-control.ryax-input(*ngIf="!(isCurrentStepSource$ | async) else isATrigger")
      nz-select(formControlName="valueType")
        nz-option(nzValue="link", nzLabel="link")
        nz-option(nzValue="static", nzLabel="static")
        nz-option(nzValue="variable", nzLabel="variable")
    ng-template.ryax-input(#isATrigger)
      nz-form-control.ryax-input
        nz-select(formControlName="valueType")
          nz-option(nzValue="static", nzLabel="static")
          nz-option(nzValue="variable", nzLabel="variable")
    nz-form-control([ngSwitch]="form.get(input.id + '.valueType')!.value")
      nz-input-group([nzSuffix]="inputClearTpl")
        ng-container(*ngSwitchCase="'static'")
          input(*ngIf="input.inputType === 'string'", nz-input, type="text", [id]="input.name", formControlName="value")
          nz-input-group(*ngIf="input.inputType === 'password'", [nzSuffix]="suffixTemplate")
            input(nz-input, [type]="passwordVisible ? 'text' : 'password'", [id]="input.name", formControlName="value")
          ng-template(#suffixTemplate)
            span(nz-icon, [id]="input.name", [nzType]="passwordVisible ? 'eye-invisible' : 'eye'", (click)="passwordVisible = !passwordVisible")

          nz-input-number(*ngIf="input.inputType === 'integer' || input.inputType === 'float'", [id]="input.name", formControlName="value")
          textarea(*ngIf="input.inputType === 'longstring'", rows="4", nz-input, [id]="input.name", formControlName="value")
          nz-select(*ngIf="input.inputType === 'enum'", [id]="input.name", formControlName="value")
            nz-option(*ngFor="let option of input.enumValues", [nzValue]="option.name", [nzLabel]="option.name")
          div.ryax-checkbox(*ngIf="input.inputType === 'boolean'")
            input([id]="input.name", type="checkbox", nz-input, formControlName="value")
            span(*ngIf="form.get(input.id + '.value')!.value === null" ) Not set (null)
            span(*ngIf="form.get(input.id + '.value')!.value === true" ) True
            span(*ngIf="form.get(input.id + '.value')!.value === false" ) False
          div(*ngIf="input.inputType === 'file' || input.inputType === 'directory'")
            ng-container(*ngIf="form.get(input.id + '.value')!.value as formValue; else uploadButton")
              | File uploaded : {{ formValue }}
              button#ryax-remove-file(nz-button, nzType="primary", nzDanger, (click)="removeFile(input.id)")
                i(nz-icon, nzType="delete", nzTheme="outline")
            ng-template(#uploadButton)
              ng-container(*ngIf="(ids$ | async) as ids")
                nz-upload([nzAction]="'/api/studio/workflows/' + ids[0] + '/modules/' + ids[1] + '/inputs/' + input.id + '/file'", (nzChange)="handleChange($event, input.id)")
                  button(nz-button, nzType="primary") Upload {{ input.inputType === 'file' ? 'file' : 'directory' }}
        ng-container(*ngSwitchCase="'link'")
          nz-select(formControlName="value", nzPlaceHolder="Choose a previous module output" )
            nz-option-group(*ngFor="let group of previousOutputs$ | async | filterByType : input.inputType", [nzLabel]="group.groupName")
              nz-option(*ngFor="let value of group.values", [nzValue]="value.value", [nzLabel]="value.name")
        ng-container(*ngSwitchCase="'variable'")
          nz-select(formControlName="value", nzPlaceHolder="Choose a project variable" )
            nz-option(*ngFor="let variable of projectVariables$ | async | filterBy : ['type'] : input.inputType", [nzLabel]="variable.name + ' — ' + variable.description", [nzValue]="variable.id")
        ng-template(#inputClearTpl)
          span(nz-icon, nzTheme="outline", nzType="close-circle", *ngIf="!(input.inputType === 'file' || input.inputType === 'directory')", (click)="clearValue(input.id)")
      p {{ input.help }}

